#include "layer.h"
#include "color.h"
#include "angle.h"
#include <wx/event.h>
#include <wx/datetime.h>

class VertexTable;
class Texture;
class FileInformation;

class ImageLayer : public Layer
{
protected:
	Angle minLat;
	Angle maxLat;
	Angle minLon;
	Angle maxLon;

	VertexTable *vertices;

	Texture *texture;
public:
	FileInformation *fileInfo;
	int meshPointCount;
	double worldRadius;

	static unsigned char *coeffs;
	static Vector *normals;
	
	ImageLayer(
		const wxString &name,
		Layer *parentLayer,
		const wxString &fileName,
		const wxString &url,
		const wxString &path,
		const Angle &minLatitude,
		const Angle &maxLatitude,
		const Angle &minLongitude,
		const Angle &maxLongitude,
		double worldRadius
		);

	~ImageLayer();

	virtual void initialize();
	virtual void update();
	virtual void render(NawiGLCanvas *glCanvas);

	virtual void createMesh();
	static void calculateNormals(VertexTable *table);
};
